Index: Singular/LIB/hnoether.lib
===================================================================
--- Singular/LIB/hnoether.lib	(revision 54ff35fb086438cda61fdfdc9ab33efa8472e4eb)
+++ Singular/LIB/hnoether.lib	(revision 7fa60f271650fb75da945dbf4eae02cf8cc5a570)
@@ -1,29 +1,29 @@
-version="$Id: hnoether.lib,v 1.43 2005-01-13 09:42:03 Singular Exp $";
+version="$Id: hnoether.lib,v 1.44 2005-04-14 15:39:20 Singular Exp $";
 category="Singularities";
 info="
 LIBRARY:  hnoether.lib   Hamburger-Noether (Puiseux) Development
-AUTHOR:   Martin Lamm,   lamm@mathematik.uni-kl.de
+AUTHORS:   Martin Lamm,      lamm@mathematik.uni-kl.de
+           Christoph Lossen, lossen@mathematik.uni-kl.de
 
 OVERVIEW:
- A library for computing the Hamburger-Noether, resp. Puiseux, development
- of a plane curve singularity following [Campillo, A.: Algebroid curves
- in positive characteristic, Springer LNM 813 (1980)]. @*
+ A library for computing the Hamburger-Noether expansion (analogue of 
+ Puiseux expansion over fields of arbitrary characteristic) of a reduced 
+ plane curve singularity following [Campillo, A.: Algebroid curves in
+ positive characteristic, Springer LNM 813 (1980)]. @*
  The library contains also procedures for computing the (topological)
  numerical invariants of plane curve singularities.
 
 MAIN PROCEDURES:
- hnexpansion(f);            Hamburger-Noether (H-N) development of f
- sethnering(hn);            changes to the hnering created by hnexpansion
- develop(f [,n]);           H-N development of irreducible curves
+ hnexpansion(f [,\"ess\"]); Hamburger-Noether (HN) expansion of f
+ develop(f [,n]);           HN expansion of irreducible plane curve germs
  extdevelop(hne,n);         extension of the H-N development hne of f
- parametrisation(f [,x]);   a parametrization of f 
- displayHNE(hne);           display H-N development as an ideal
- invariants(f);             invariants of f, e.g. the characteristic exponents
- displayInvariants(f);      display invariants of f
- multsequence(f);           sequence of multiplicities
- displayMultsequence(f);    display sequence of multiplicities
+ param(L [,s]);             parametrization of branches described by HN data
+ displayHNE(hne);           display HN development as an ideal
+ invariants(hne);           invariants of f, e.g. the characteristic exponents
+ displayInvariants(hne);    display invariants of f
+ multsequence(hne);         sequence of multiplicities
+ displayMultsequence(hne);  display sequence of multiplicities
  intersection(hne1,hne2);   intersection multiplicity of two curves
- stripHNE(hne);             reduce amount of memory consumed by hne
- is_irred(f);               test if f is irreducible
+ is_irred(f);               test if f is irreducible as power series
  delta(f);                  delta invariant of f
  newtonpoly(f);             (local) Newton polygon of f
@@ -32,4 +32,5 @@
 
 AUXILIARY PROCEDURES:
+ stripHNE(hne);             reduce amount of memory consumed by hne
  puiseux2generators(m,n);   convert Puiseux pairs to generators of semigroup
  separateHNE(hne1,hne2);    number of quadratic transf. needed for separation
@@ -41,9 +42,6 @@
 ";
 
-// HNdevelop(f);              Hamburger-Noether (H-N) development of f
-// reddevelop(f);             H-N development of reducible curves
-// essdevelop(f);             H-N development of essential branches
+// essdevelop(f);             HN expansion of essential branches
 // multiplicities(hne);       multiplicities of blowed up curves
-
 
 ///////////////////////////////////////////////////////////////////////////////
@@ -85,6 +83,6 @@
 //       static procedures not useful for interactive use:
 // polytest(f);        tests coefficients and exponents of poly f
-// extractHNEs(H,t);   extracts output H of HN to output of reddevelop
-// HN(f,grenze);       recursive subroutine for reddevelop
+// extractHNEs(H,t);   extracts output H of HN to output of hnexpansion
+// HN(f,grenze);       recursive subroutine for hnexpansion
 // constructHNEs(...); subroutine for HN
 }
@@ -182,5 +180,5 @@
 ///////////////////////////////////////////////////////////////////////////////
 
-proc T2_Transform (poly f, number d, int M, int N, poly refpoly)
+proc T2_Transform (poly f_neu, number d, int M, int N, poly refpoly)
 "USAGE:   T2_Transform(f,d,M,N,ref); f poly, d number; M,N int; ref poly
 RETURN:  list: poly T2(f,d',M,N), number d' in \{ d, 1/d \}
@@ -219,12 +217,13 @@
   }
  //------------------- Durchfuehrung der Transformation T2 --------------------
-  f=Tstar(f);
+  f_neu=Tstar(f_neu);
   refpoly=Tstar(refpoly);
- //--- dividiere f so lange durch x & y, wie die Div. aufgeht, benutze ein  ---
- //--- Referenzpolynom mit gleichem Newtonpolynom wie f zur Beschleunigung: ---
+  //--- dividiere f_neu so lange durch x & y, wie die Division aufgeht, 
+  //    benutze ein Referenzpolynom mit gleichem Newtonpolynom wie f_neu zur 
+  //    Beschleunigung: ---
   for (hilf=refpoly/xp; hilf*xp==refpoly; hilf=refpoly/xp) {refpoly=hilf; s++;}
   for (hilf=refpoly/yp; hilf*yp==refpoly; hilf=refpoly/yp) {refpoly=hilf; t++;}
-  f=f/(xp^s*yp^t);
-  return(list(T1(f),d));
+  f_neu=f_neu/(xp^s*yp^t);
+  return(list(T1(f_neu),d));
 }
 example
@@ -807,5 +806,6 @@
     if (Abbruch == 0) {
       f = T1_Transform(f,delt,M/ e);
-      dbprint(printlevel-voice+2,"a("+string(zeile)+","+string(Q)+") = "+string(delt)); 
+      dbprint(printlevel-voice+2,"a("+string(zeile)+","+string(Q)+") = "
+              +string(delt)); 
       a(zeile)[Q]=delt;
       if (defined(HNDebugOn)) {"transformed polynomial: ",f;}}
@@ -902,5 +902,5 @@
   // (the missing x in the last line indicates that it is not complete.)
   hne[2];
-  parametrisation(hne);
+  param(hne);
   // parametrization:   x(t)= -t^14+O(t^21),  y(t)= -3t^98+O(t^105)
   // (the term -t^109 in y may have a wrong coefficient)
@@ -912,173 +912,14 @@
 ///////////////////////////////////////////////////////////////////////////////
 
-proc parametrisation
-"USAGE: parametrisation(INPUT [,x]); INPUT list or poly, x int (optional)
-ASSUME: INPUT is either a bivariate polynomial f defining a plane curve 
-        singularity, or it is the output of @code{hnexpansion(f[,\"ess\"])}, 
-        or of @code{develop(f)}, or of @code{extdevelop(develop(f),n)}, 
-        or  the list @{hne} in the ring created by @code{hnexpansion(f)} 
-        respectively one entry thereof.
-RETURN: a list L containing a parametrization L[i] for each branch f[i] of f 
-        in the following format: @*
-        - if only the list INPUT is given, L[i] is an ideal of two polynomials 
-        p[1],p[2]: if the HNE of was finite  then f[i](p[1],p[2])=0; if not, 
-        the \"real\" parametrization will be two power series and p[1],p[2] are
-        truncations of these series.@*
-        - if the optional parameter x is given, L[i] is itself a list: 
-        L[i][1] is the parametrization ideal as above and L[i][2] is an intvec 
-        with two entries indicating the highest degree up to which the 
-        coefficients of the monomials in L[i][1] are exact (entry -1 means that
-        the corresponding parametrization is exact).
-NOTE:   If the basering has only 2 variables, the first variable is chosen
-        as indefinite. Otherwise, the 3rd variable is chosen. @*
-        In case the Hamburger-Noether expansion of the curve f is needed
-        for other purposes as well it is better to calculate this first
-        with the aid of @code{hnexpansion} and use it as input instead of
-        the polynomial itself.
-SEE ALSO: develop, extdevelop
-KEYWORDS: parametrization
-EXAMPLE: example parametrisation;     shows an example
-         example develop;         shows another example
-"
-{
-  ////////////////////////////////////////////////////////////////////////
-  // Decide on the type of input
-  ////////////////////////////////////////////////////////////////////////
-  // Do the case where the input is a polynomial
-  if (typeof(#[1])=="poly")
-  {
-    list HNEXPANSION=hnexpansion(#[1]);
-    if (size(#)==1)
-    {
-      return(parametrisation(HNEXPANSION));
-    }
-    else
-    {
-      return(parametrisation(HNEXPANSION,1));
-    }
-  }
-  // Do the case where the input is not a polynomial.
-  int zusatz;  
-  if (typeof(#[1])=="list")
-  {
-    if (typeof(#[1][1])=="ring")
-    { // Input is a HNEring and extra input x exists.
-      zusatz=1;
-      def HNE_RING=#[1][1];
-    }
-    else
-    {
-      if (typeof(#[1][1])=="list")
-      { // Input is a reducible HN-expansion and extra input x exists.
-        zusatz=1;
-        list hne=#[1];
-      }
-      else
-      {
-        if (typeof(#[size(#)])=="list")  
-        { // Input is a reducible HN-expansion and no extra input exists.
-          list hne=#;
-        }
-        else  
-        { // Input is an irreducible HN-expansion and extra input x exists 
-          list hne;
-          hne[1]=#[1];
-          zusatz=1;
-        }
-      }
-    }
-  }
-  if (typeof(#[1])=="matrix")
-  {
-    list hne;
-    hne[1]=#;
-  }
-  if (typeof(#[1])=="ring")
-  { // Input is a HNEring and no extra input exists.
-    def HNE_RING=#[1];
-  }
-  ////////////////////////////////////////////////////////////////////////////
-  // Calculate the parametrization.
-  if (defined(HNE_RING))
-  {
-    def rettering=basering;
-    setring HNE_RING;
-  }
-  int r=size(hne);
-  list ErGeBnIs;
-  // Calculate the parametrization for each branch with the aid of param.
-  for (int lauf=1;lauf<=r;lauf++)
-  {
-    if (zusatz==1)
-    {
-      ErGeBnIs[lauf]=param(hne[lauf],1);
-    }
-    else
-    {
-      ErGeBnIs[lauf]=param(hne[lauf]);
-    }
-  }
-  // Map the parametrization to the basering, if necessary, and return it.
-  if (defined(HNE_RING))
-  {
-    setring rettering;
-    list erg=fetch(HNE_RING,ErGeBnIs);
-    kill HNE_RING;
-    // If the basering has 3 variables, choose the third variable for the parametrization.
-    if (nvars(rettering)>=3)
-    {
-      for (lauf=1;lauf<=r;lauf++)
-      {
-        if (zusatz==1)
-        {
-          erg[lauf][1]=subst(erg[lauf][1],var(1),var(3));
-        }
-        else
-        {
-          erg[lauf]=subst(erg[lauf],var(1),var(3));
-        }
-      }
-    }
-    return(erg);
-  }
-  else
-  {
-    return(ErGeBnIs);
-  }
-}
-example
-{ "EXAMPLE:"; echo = 2;
- ring exring=0,(x,y,t),ds;
- // 1st Example: input is a polynomial
- poly g=(x2-y3)*(x3-y5);
- parametrisation(g);
- // 2nd Example: input is the ring of a Hamburger-Noether expansion
- poly h=x2-y2-y3;
- list hn=hnexpansion(h);
- parametrisation(h,1);
- // 3rd Example: input is a Hamburger-Noether expansion
- poly f=x3+2xy2+y2;
- list hne=develop(f);
- list hne_extended=extdevelop(hne,10);
-            //   compare the matrices ...
- print(hne[1]);
- print(hne_extended[1]);
-            // ... and the resulting parametrizations:
- parametrisation(hne);
- parametrisation(hne_extended);
- parametrisation(hne_extended,0);
-}
-
-
-proc param
-"USAGE:  param(L [,x]); L list, x any type (optional)
+proc param (list L, list #)
+"USAGE:  param(L [,s]); L list, s any type (optional)
 ASSUME:  L is the output of @code{develop(f)}, or of
-        @code{extdevelop(develop(f),n)}, or one entry in the list @code{hne}
-        in the ring created by @code{hnexpansion(f[,\"ess\"])}.
+        @code{extdevelop(develop(f),n)}, or (one entry in) the list of HN 
+        data created by @code{hnexpansion(f[,\"ess\"])}.
 RETURN: a parametrization for f in the following format: @*
         - if only the list L is given, the result is an ideal of two
         polynomials p[1],p[2]: if the HNE was finite then f(p[1],p[2])=0};
-        if not, the \"real\" parametrization will be two power series and
-        p[1],p[2] are truncations of these series.@*
+        if not, the true parametrization will be given by two power series, 
+        and p[1],p[2] are truncations of these series.@*
         - if the optional parameter x is given, the result is a list l:
         l[1]=param(L) (ideal) and l[2]=intvec with two entries indicating
@@ -1088,5 +929,5 @@
 NOTE:   If the basering has only 2 variables, the first variable is chosen
         as indefinite. Otherwise, the 3rd variable is chosen.
-SEE ALSO: parametrization, develop, extdevelop
+SEE ALSO: develop, extdevelop
 KEYWORDS: parametrization
 EXAMPLE: example param;     shows an example
@@ -1095,16 +936,23 @@
 {
  //-------------------------- Initialisierungen -------------------------------
- if (typeof(#[1])=="list") {
-   list Li=#[1];
-   matrix m=Li[1];
-   intvec v=Li[2];
-   int switch=Li[3];
-   int return_list=1;
+ int return_list;
+ if (size(#)>0) { return_list=1; }
+
+ if (typeof(L[1])=="list") { // output of hnexpansion (> 1 branch)
+   list Ergebnis;
+   for (int i=1; i<=size(L); i++) {
+     dbprint(printlevel-voice+4,"// Parametrization of branch number "
+       +string(i)+" computed.");  
+     printlevel=printlevel+1;
+     if (return_list==1) { Ergebnis[i]=param(L[i],1); }
+     else                { Ergebnis[i]=param(L[i]); }
+     printlevel=printlevel-1;
+   }
+   return(Ergebnis);
  }
  else {
-   matrix m=#[1];
-   intvec v=#[2];
-   int switch=#[3];
-   int return_list=0;
+   matrix m=L[1];
+   intvec v=L[2];
+   int switch=L[3];
  }
  if (switch==-1) {
@@ -1123,5 +971,6 @@
    for (i=1; i<=v[zeile]; i++) {
      z(zeile)=z(zeile)+m[zeile,i]*z(zeile+1)^i;
- }}
+   }
+ }
  else {
    untervor=1;         // = Untergrad der vorhergehenden Zeile
@@ -1132,5 +981,6 @@
        if ((untergrad==0) and (m[zeile,i]!=0)) {untergrad=i;}
                        // = Untergrad der aktuellen Zeile
-   }}
+     }
+   }
    else {
      fehler= -v[zeile];
@@ -1138,5 +988,6 @@
        z(zeile)=z(zeile)+m[zeile,i]*z(zeile+1)^i;
        if ((untergrad==0) and (m[zeile,i]!=0)) {untergrad=i;}
-   }}
+     }
+   }
  }
  //------------- Parametrisierung der restlichen Zeilen der HNE ---------------
@@ -1155,5 +1006,6 @@
      hilf=untergrad;
      untergrad=untergrad*v[zeile]+untervor;
-     untervor=hilf;}}    // untervor = altes untergrad
+     untervor=hilf;}     // untervor = altes untergrad
+   }
    else {
      fehlervor=fehler;
@@ -1161,18 +1013,20 @@
      untervor=untergrad;
      untergrad=untergrad*beginn;
- }}
+   }
+ }
  //--------------------- Ausgabe der Fehlerabschaetzung -----------------------
  if (switch==0) {
    if (fehler>0) {
      if (fehlervor>0) {
-       if ((voice==2) && (printlevel > -1)) {
-         "// ** Warning: result is exact up to order",fehlervor-1,"in",
-         maxideal(1)[1],"and",fehler-1,"in",maxideal(1)[2],"!";
-     }}
+       dbprint(printlevel-voice+4,""+
+         "// ** Warning: result is exact up to order "+string(fehlervor-1)+
+         " in "+ string(var(1))+" and "+string(fehler-1)+" in " +
+         string(var(2))+" !"); 
+     }
      else {
-       if ((voice==2) && (printlevel > -1)) {
-         "// ** Warning: result is exact up to order",fehler-1,"in",
-         maxideal(1)[2],"!";
-     }}
+       dbprint(printlevel-voice+4,""+
+         "// ** Warning: result is exact up to order "+ string(fehler-1)+
+         " in "+string(var(2))+" !");
+     }
    }
    if (return_list==0) { return(ideal(z(2),z(1))); }
@@ -1182,13 +1036,14 @@
    if (fehler>0) {
      if (fehlervor>0) {
-      if ((voice==2) && (printlevel > -1)) {
-        "// ** Warning: result is exact up to order",fehler-1,"in",
-        maxideal(1)[1],"and",fehlervor-1,"in",maxideal(1)[2],"!";
-     }}
+       dbprint(printlevel-voice+4,""+
+         "// ** Warning: result is exact up to order "+string(fehler-1)+
+         " in "+ string(var(1))+" and "+string(fehlervor-1)+" in " +
+         string(var(2))+" !"); 
+     }
      else {
-      if ((voice==2) && (printlevel > -1)) {
-        "// ** Warning: result is exact up to order",fehler-1,"in",
-        maxideal(1)[1],"!";
-     }}
+       dbprint(printlevel-voice+4,""+
+        "// ** Warning: result is exact up to order "+ string(fehler-1)+
+         " in "+string(var(1))+" !");
+     }
    }
    if (return_list==0) { return(ideal(z(1),z(2))); }
@@ -1202,5 +1057,5 @@
  list hne=develop(f);
  list hne_extended=extdevelop(hne,10);
-            //   compare the matrices ...
+            //   compare the HNE matrices ...
  print(hne[1]);
  print(hne_extended[1]);
@@ -1209,34 +1064,37 @@
  param(hne_extended);
  param(hne_extended,0);
-}
+
+ // An example with more than one branch:
+ list L=hnexpansion(f*(x2+y4));
+ def HNring = L[1]; setring HNring;
+ param(hne);
+}
+
 ///////////////////////////////////////////////////////////////////////////////
 
 proc invariants
 "USAGE:   invariants(INPUT); INPUT list or poly
-ASSUME:  INPUT is the output of @code{develop(f)}, or of
-         @code{extdevelop(develop(f),n)}, or one entry in the list @code{hne} 
-         of the HNEring created by @code{hnexpansion}.
-RETURN:  list, if INPUT contains a valid HNE:
+ASSUME:  @code{INPUT} is the output of @code{develop(f)}, or of
+         @code{extdevelop(develop(f),n)}, or one entry of the list of HN data 
+         computed by @code{hnexpansion(f[,\"ess\"])}.
+RETURN:  list @code{INV} of the following format:
 @format
-    invariants(INPUT)[1]:  intvec    (characteristic exponents)
-    invariants(INPUT)[2]:  intvec    (generators of the semigroup)
-    invariants(INPUT)[3]:  intvec    (Puiseux pairs, 1st components)
-    invariants(INPUT)[4]:  intvec    (Puiseux pairs, 2nd components)
-    invariants(INPUT)[5]:  int       (degree of the conductor)
-    invariants(INPUT)[6]:  intvec    (sequence of multiplicities)
+    INV[1]:  intvec    (characteristic exponents)
+    INV[2]:  intvec    (generators of the semigroup)
+    INV[3]:  intvec    (Puiseux pairs, 1st components)
+    INV[4]:  intvec    (Puiseux pairs, 2nd components)
+    INV[5]:  int       (degree of the conductor)
+    INV[6]:  intvec    (sequence of multiplicities)
 @end format
-         an empty list, if INPUT contains no valid HNE.
-ASSUME:  INPUT is bivariate polynomial f or the output of @code{hnexpansion(f[,\"ess\"])}, 
-         or the list @code{hne} in the HNEring created by @code{hnexpansion}.
-RETURN:  list INV, such that INV[i] is the output of @code{invariants(develop(f[i]))}
-         as above, where f[i] is the ith branch of the curve f, and the last 
-         entry contains further invariants of f in the format:
+         If @code{INPUT} contains no valid HN expansion, the empty list is 
+         returned.
+ASSUME:  @code{INPUT} is a bivariate polynomial f, or the output of 
+         @code{hnexpansion(f)}, or the list of HN data computed by 
+         @code{hnexpansion(f [,\"ess\"])}.
+RETURN:  list @code{INV}, such that @code{INV[i]} coincides with the output of 
+         @code{invariants(develop(f[i]))}, where f[i] is the i-th branch of 
+         f, and the last entry of @code{INV} contains further invariants of 
+         f in the format:
 @format
-    INV[i][1]    : intvec    (characteristic exponents)
-    INV[i][2]    : intvec    (generators of the semigroup)
-    INV[i][3]    : intvec    (Puiseux pairs, 1st components)
-    INV[i][4]    : intvec    (Puiseux pairs, 2nd components)
-    INV[i][5]    : int       (degree of the conductor)
-    INV[i][6]    : intvec    (sequence of multiplicities)
     INV[last][1] : intmat    (contact matrix of the branches)
     INV[last][2] : intmat    (intersection multiplicities of the branches)
@@ -1247,5 +1105,5 @@
          with the aid of @code{hnexpansion} and use it as input instead of
          the polynomial itself.
-SEE ALSO: develop, displayInvariants, multsequence, intersection
+SEE ALSO: hnexpansion, develop, displayInvariants, multsequence, intersection
 KEYWORDS: characteristic exponents; semigroup of values; Puiseux pairs;
           conductor, degree; multiplicities, sequence of
@@ -1253,62 +1111,61 @@
 "
 {
- //---- INPUT = poly, or HNEring, or hne of reducible curve  --------------------
-  if (typeof(#[1])!="matrix")
-  {
-    if (typeof(#[1])=="poly")
-    {
-      list HNEXPANSION=hnexpansion(#[1]);
-      return(invariants(HNEXPANSION));
-    }
-    if (typeof(#[1])=="ring")
-    {
-      def H_N_E_R_I_N_G=#[1];
-      def rette_ring=basering;
-      setring H_N_E_R_I_N_G;
-    }
-    if (typeof(#[1])=="list")
-    {
-      list hne=#;
-    }
-    list ErGeBnIs;
-    for (int lauf=1;lauf<=size(hne);lauf++)
-    {
-      ErGeBnIs[lauf]=invariants(hne[lauf]);
-    }
-    // Calculate the intersection matrix and the intersection multiplicities.
-    intmat contact[size(hne)][size(hne)];
-    intmat intersectionmatrix[size(hne)][size(hne)];
-    int Lauf;
-    for (lauf=1;lauf<=size(hne);lauf++)
-    {
-      for (Lauf=lauf+1;Lauf<=size(hne);Lauf++)
-      {
-        contact[lauf,Lauf]=separateHNE(hne[lauf],hne[Lauf]);
-        contact[Lauf,lauf]=contact[lauf,Lauf];
-        intersectionmatrix[lauf,Lauf]=intersection(hne[lauf],hne[Lauf]);
-        intersectionmatrix[Lauf,lauf]=intersectionmatrix[lauf,Lauf];
+ //---- INPUT = poly, or HNEring, or hne of reducible curve  -----------------
+ if (typeof(#[1])!="matrix") {
+   if (typeof(#[1])=="poly") {
+      list L=hnexpansion(#[1]);
+      if (typeof(L[1])=="ring") {
+        def altring = basering;
+        def HNring = L[1]; setring HNring;
+        list Ergebnis = invariants(hne);
+        setring altring;
+        kill HNring;
+        return(Ergebnis);
       }
-    }
-    // Calculate the delta invariant.
-    int inters;
-    int del=ErGeBnIs[size(hne)][5]/2;
-    for(lauf=1;lauf<=size(hne)-1;lauf++)
-    {
-      del=del+ErGeBnIs[lauf][5]/2;
-      for(Lauf=lauf+1;Lauf<=size(hne);Lauf++)
-      {
+      else {
+        return(invariants(L));
+      }  
+   }
+   if (typeof(#[1])=="ring") {
+     def altring = basering;
+     def HNring = #[1]; setring HNring;
+     list Ergebnis = invariants(hne);
+     setring altring;
+     kill HNring;
+     return(Ergebnis);  
+   }
+   if (typeof(#[1])=="list") {
+     list hne=#;
+     list Ergebnis;
+     for (int lauf=1;lauf<=size(hne);lauf++) {
+       Ergebnis[lauf]=invariants(hne[lauf]);
+     }
+     // Calculate the intersection matrix and the intersection multiplicities.
+     intmat contact[size(hne)][size(hne)];
+     intmat intersectionmatrix[size(hne)][size(hne)];
+     int Lauf;
+     for (lauf=1;lauf<=size(hne);lauf++) {
+       for (Lauf=lauf+1;Lauf<=size(hne);Lauf++) {
+         contact[lauf,Lauf]=separateHNE(hne[lauf],hne[Lauf]);
+         contact[Lauf,lauf]=contact[lauf,Lauf];
+         intersectionmatrix[lauf,Lauf]=intersection(hne[lauf],hne[Lauf]);
+         intersectionmatrix[Lauf,lauf]=intersectionmatrix[lauf,Lauf];
+       }
+     }
+     // Calculate the delta invariant.
+     int inters;
+     int del=Ergebnis[size(hne)][5]/2;
+     for(lauf=1;lauf<=size(hne)-1;lauf++) {
+       del=del+Ergebnis[lauf][5]/2;
+       for(Lauf=lauf+1;Lauf<=size(hne);Lauf++) {
          inters=inters+intersectionmatrix[lauf,Lauf];
-      }
-    }
-    del=del+inters;
-    list LAST=contact,intersectionmatrix,del;
-    ErGeBnIs[size(hne)+1]=LAST;
-    if (defined(H_N_E_R_I_N_G))
-    {
-      setring rette_ring;
-      kill H_N_E_R_I_N_G;
-    }
-    return(ErGeBnIs);
-  }
+       }
+     }
+     del=del+inters;
+     list LAST=contact,intersectionmatrix,del;
+     Ergebnis[size(hne)+1]=LAST;
+     return(Ergebnis);
+   }
+ }
  //-------------------------- Initialisierungen -------------------------------
  matrix m=#[1];
@@ -1418,11 +1275,12 @@
 proc displayInvariants
 "USAGE:  displayInvariants(INPUT); INPUT list or poly
-ASSUME:  INPUT is a bivariate polynomial, or the output of @code{develop(f)}, or of
-         @code{extdevelop(develop(f),n)}, or (one entry of) the list @code{hne}
-         in the ring created by @code{hnexpansion(f[,\"ess\"])}.
+ASSUME:  @code{INPUT} is a bivariate polynomial, or the output of 
+         @code{develop(f)}, resp. of @code{extdevelop(develop(f),n)}, or (one 
+         entry of) the list of HN data computed by 
+         @code{hnexpansion(f[,\"ess\"])}.
 RETURN:  none
 DISPLAY: invariants of the corresponding branch, resp. of all branches,
          in a better readable form.
-NOTE:    In case the Hamburger-Noether expansion of the curve f is needed
+NOTE:    If the Hamburger-Noether expansion of the curve f is needed
          for other purposes as well it is better to calculate this first
          with the aid of @code{hnexpansion} and use it as input instead of
@@ -1432,22 +1290,24 @@
 "
 {
-  // INPUT = poly or ring
-  if (typeof(#[1])=="poly") 
-  {
-    list HNEXPANSION=hnexpansion(#[1]);
-    displayInvariants(HNEXPANSION);
-    return();
-  }
-  if (typeof(#[1])=="ring")
-  {
-    def H_N_E_RING=#[1];
-    def rettering=basering;
-    setring H_N_E_RING;
-    displayInvariants(hne);
-    setring rettering;
-    kill H_N_E_RING;
-    return();
-  }
-  // INPUT = hne of a plane curve
+ // INPUT = poly or ring
+ if (typeof(#[1])=="poly") {
+   list L=hnexpansion(#[1]);
+   if (typeof(L[1])=="ring") {
+     def HNring = L[1]; setring HNring;
+     displayInvariants(hne);
+     return();
+   }
+   else {
+     displayInvariants(L);
+     return();
+   }
+ }
+ if (typeof(#[1])=="ring")
+ {
+   def HNring = #[1]; setring HNring;
+   displayInvariants(hne);
+   return();
+ }
+ // INPUT = hne of a plane curve
  int i,j,k,mul;
  string Ausgabe;
@@ -1739,10 +1599,7 @@
 example
 {
-  // ------ the example starts here -------
   "EXAMPLE:"; echo = 2;
   ring r=0,(x,y),dp;
-  list hn=hnexpansion((x2-y3)*(x2+y3));
-  def HNEring=hn[1];
-  setring HNEring;
+  list hne=hnexpansion((x2-y3)*(x2+y3));
   intersection(hne[1],hne[2]);
 }
@@ -1751,11 +1608,14 @@
 proc multsequence
 "USAGE:   multsequence(INPUT); INPUT list or poly 
-ASSUME:  INPUT is the output of @code{develop(f)}, or of @code{extdevelop(develop(f),n)}, 
-         or one entry in the list @code{hne} of the ring created by @code{hnexpansion(f)}.
-RETURN:  intvec corresponding to the multiplicity sequence of (a branch)
-         of the curve (the same as @code{invariants(INPUT)[6]}).
-
-ASSUME:  INPUT is a bivariate polynomial, or the output of @code{hnexpansion(f)},
-         or the list @code{hne} in the ring created by @code{hnexpansion(f)}.
+ASSUME:  @code{INPUT} is the output of @code{develop(f)}, or of
+         @code{extdevelop(develop(f),n)}, or one entry of the list of HN data 
+         computed by @code{hnexpansion(f[,\"ess\"])}.
+RETURN:  intvec corresponding to the multiplicity sequence of the irreducible
+         plane curve singularity described by the HN data (return value
+         coincides with @code{invariants(INPUT)[6]}).
+
+ASSUME:  @code{INPUT} is a bivariate polynomial f, or the output of 
+         @code{hnexpansion(f)}, or the list of HN data computed by 
+         @code{hnexpansion(f [,\"ess\"])}.
 RETURN:  list of two integer matrices:
 @texinfo
@@ -1772,9 +1632,11 @@
 @end table
 @end texinfo
-NOTE:  The order of elements of the list @code{hne} obtained from @code{hnexpansion(f[,\"ess\")}
-       must not be changed (because then the coincident infinitely near points
-       couldn't be grouped together, cf. meaning of 2nd intmat in example).
-       Hence, it is not wise to compute the HNE of several polynomials
-       separately, put them into a list INPUT and call @code{multsequence(INPUT)}. @*
+NOTE:  The order of the elements of the list of HN data obtained from 
+       @code{hnexpansion(f [,\"ess\"])} must not be changed (because otherwise
+       the coincident infinitely near points couldn't be grouped together, 
+       see the meaning of the 2nd intmat in the example).
+       Hence, it is not wise to compute the HN expansion of polynomial factors
+       separately, put them into a list INPUT and call 
+       @code{multsequence(INPUT)}. @*
        Use @code{displayMultsequence} to produce a better readable output for
        reducible curves on the screen. @*
@@ -1789,19 +1651,26 @@
 {
  //---- INPUT = poly, or HNEring --------------------
-  if (typeof(#[1])=="poly")
-  {
-    list HNEXPANSION=hnexpansion(#[1]);
-    return(multsequence(HNEXPANSION));
-  }
-  if (typeof(#[1])=="ring")
-  {
-    def H_N_ER_I_N_G=#[1];
-    def ret_te_ring=basering;
-    setring H_N_ER_I_N_G;
-    list ErGeBnIs=multsequence(hne);
-    setring ret_te_ring;
-    kill H_N_ER_I_N_G;
-    return(ErGeBnIs);
-  }
+ if (typeof(#[1])=="poly") {
+   list L=hnexpansion(#[1]);
+   if (typeof(L[1])=="ring") {
+     def altring = basering;
+     def HNring = L[1]; setring HNring;
+     list Ergebnis = multsequence(hne);
+     setring altring;
+     kill HNring;
+     return(Ergebnis);
+   }
+   else {
+     return(multsequence(L));
+   }  
+ }
+ if (typeof(#[1])=="ring") {
+   def altring = basering;
+   def HNring = #[1]; setring HNring;
+   list Ergebnis = multsequence(hne);
+   setring altring;
+   kill HNring;
+   return(Ergebnis);  
+ }
  //-- entferne ueberfluessige Daten zur Erhoehung der Rechengeschwindigkeit: --
  #=stripHNE(#);
@@ -1886,15 +1755,7 @@
 example
 {
-  // -------- prepare for example ---------
-  if (nameof(basering)=="HNEring") {
-   def rettering=HNEring;
-   kill HNEring;
-  }
-  // ------ the example starts here -------
   "EXAMPLE:"; echo = 2;
   ring r=0,(x,y),dp;
-  list hn=hnexpansion((x6-y10)*(x+y2-y3)*(x+y2+y3));   // 4 branches
-  def HNEring=hn[1];
-  setring HNEring;
+  list hne=hnexpansion((x6-y10)*(x+y2-y3)*(x+y2+y3));
   multsequence(hne[1]),"  |  ",multsequence(hne[2]),"  |  ",
   multsequence(hne[3]),"  |  ",multsequence(hne[4]);
@@ -1902,12 +1763,4 @@
   // The meaning of the entries of the 2nd matrix is as follows:
   displayMultsequence(hne);
-  echo = 0;
-  // --- restore HNEring if previously defined ---
-  kill HNEring,r;
-  if (defined(rettering)) {
-   setring rettering;
-   def HNEring=rettering;
-   export HNEring;
-  }
 }
 ///////////////////////////////////////////////////////////////////////////////
@@ -1915,7 +1768,8 @@
 proc displayMultsequence
 "USAGE:   displayMultsequence(INPUT); INPUT list or poly
-ASSUME:  INPUT is a bivariate polynomial, or the output of @code{develop(f)}, 
-         or of @code{extdevelop(develop(f),n)}, or of of @code{hnexpansion(f[,\"ess\"])}, 
-         or (one entry in) the list @code{hne} of the ring created by @code{hnexpansion(f[,\"ess \"])}.
+ASSUME:  @code{INPUT} is a bivariate polynomial, or the output of 
+         @code{develop(f)}, resp. of @code{extdevelop(develop(f),n)}, or (one 
+         entry of) the list of HN data computed by @code{hnexpansion(f[,\"ess\"])}, 
+         or the output of @code{hnexpansion(f)}.
 RETURN:  nothing
 DISPLAY: the sequence of multiplicities:
@@ -1923,5 +1777,5 @@
  - if @code{INPUT=develop(f)} or @code{INPUT=extdevelop(develop(f),n)} or @code{INPUT=hne[i]}:
                       @code{a , b , c , ....... , 1}
- - if @code{INPUT=f} or @code{INPUT=hnexpansion(f[,\"ess\"])} or @code{INPUT=hne}:
+ - if @code{INPUT=f} or @code{INPUT=hnexpansion(f)} or @code{INPUT=hne}:
                       @code{[(a_1, .... , b_1 , .... , c_1)],}
                       @code{[(a_2, ... ), ... , (... , c_2)],}
@@ -1933,5 +1787,5 @@
        @code{(...)} indicating branches meeting in an infinitely near point.
 @end format
-NOTE:  The same restrictions for INPUT as in @code{multsequence} apply.@*
+NOTE:  The Same restrictions as in @code{multsequence} apply for the input.@*
        In case the Hamburger-Noether expansion of the curve f is needed
        for other purposes as well it is better to calculate this first
